<%@ Register TagPrefix="wi" TagName="Layout" Src="~/app_data/auth/include/layout.ascx" %>
<%
// login.aspx
// Copyright (c) 2002 - 2006 Citrix Systems, Inc. All Rights Reserved.
// Web Interface 4.5.1.8215
%>

<%@ Import namespace="com.citrix.wi.ui" %>
<%@ Import namespace="com.citrix.authentication.tokens" %>
<%@ Import namespace="com.swivelsecure.pinsafe" %>

<!--#include file="~/app_data/auth/serverscripts/constants.aspxf"-->
<!--#include file="~/app_data/auth/serverscripts/include.aspxf"-->
<!--#include file="~/app_data/auth/serverscripts/login.aspxf"-->
<!--#include file="~/app_data/auth/serverscripts/loginNDS.aspxf"-->

<script runat="server">
    LoginPageControl viewControl = new LoginPageControl();
    ToolbarControl toolbarControl = new ToolbarControl();
    WelcomeControl welcomeControl = new WelcomeControl();

    void Page_Load(object sender, System.EventArgs e) {
        Context.Items.Add( "viewControl", viewControl );
        Context.Items.Add( "toolbarControl", toolbarControl );
        Context.Items.Add( "welcomeControl", welcomeControl );

        layout.PageClientScript = "~/auth/clientscripts/loginClientScript.ascx";
        layout.PageView = "loginView.ascx";
        layout.FormAction = FORM_POSTBACK;
    }

    UserEnvironmentAdaptor envAdaptor = null;
</script>
<%
if ( Request.HttpMethod == "GET" && clientDetectionRequired() ) {
%>
<!--#include file="~/app_data/auth/include/clientdetect.inc" -->
<%
} else {

    envAdaptor = getUserEnvAdaptor();


    // Check whether the user has just logged out after using smartcard,
    // without closing their browser
    bool isSMCLoggedOut = equalsIgnoreCase((string) envAdaptor.getClientSessionState().get(COOKIE_SMC_LOGGED_OUT), VAL_ON);

    // Whether to do silent authentication or not
    // Do not do silent authentication if:
    //    - it has been disallowed (e.g. in preferences)
    //    - the user has come here from the logged out page
    //    - the user has just logged off after using a smartcard, without closing their browser
    bool allowSilentAuth = !equalsIgnoreCase(VAL_OFF, (string) getUserEnvAdaptor().getClientSessionState().get(COOKIE_ALLOW_SILENT))
            && (Request.QueryString[QSTR_FROM_LOGGEDOUT_PAGE] == null)
            && (!isSMCLoggedOut);

    // Check for bookmarked URL to store
    string initialURL = getAuthenticationState(Context).getInitialURL();
    getAuthenticationState(Context).setInitialURL(null);
    string appId = null;

    if (initialURL != null ) {
        // Direct launch mode
        appId = getAppIdFromUrl(initialURL);
     } else {
        // Launching an application and loading applist
        appId = (string)getUserEnvAdaptor().getClientSessionState().get(SV_LAUNCH_APP);
    }

    if (appId != null){
            Context.Items.Add(DIRECT_LAUNCH,true);
            if(getConfiguration().getEnablePassthroughURLs()) {
                getUserEnvAdaptor().getClientSessionState().put(SV_LAUNCH_APP, appId);
            }else{
                allowSilentAuth = false;
            }
    }


    bool bFederatedEnabled = getAuthenticationConfiguration().isEnabledMethod(AuthMethod.FEDERATED);
    if (bFederatedEnabled && (Request.QueryString[QSTR_MSG_KEY] == null)) {
        // Only perform federated authentication if no message needs to be displayed
        getAuthenticationState(Context).addPageToQueueHead("federated", null);
        getAuthenticationState(Context).pageCompleted();

        // Store the logon type
        authStoreLogonType( AuthMethod.FEDERATED );
        envAdaptor.commitState();
        envAdaptor.destroy();

        // redirect to federated page.
        Response.Redirect(getAuthenticationState(Context).getCurrentPage(), true);
    }

    bool bAGELoggedOut = equalsIgnoreCase( (string) envAdaptor.getClientSessionState().get(COOKIE_AGE_LOGGED_OUT), VAL_ON );

    if ( isAGEIntegrationEnabled() ) {
        System.Collections.Hashtable parameters = new System.Collections.Hashtable();
        getAuthenticationState(Context).addPageToQueueHead("ageauthenticate", parameters);
        getAuthenticationState(Context).addPageToQueueHead("agecallback", parameters);
        getAuthenticationState(Context).addPageToQueueHead("agesso", parameters);
        getAuthenticationState(Context).pageCompleted();

        // Store the logon type
        authStoreLogonType( AuthMethod.AGE_PASSTHROUGH );
        envAdaptor.commitState();
        envAdaptor.destroy();

        // Don't do a server side redirect as then IIS sends NTLM headers when it sees the 401
        Response.Redirect(getAuthenticationState(Context).getCurrentPage(), true);
    }

    AuthenticationConfiguration authConfig = getAuthenticationConfiguration();

    if ( Request.HttpMethod == "GET" ) {
        // This may or may not return
        if ( Request.QueryString[QSTR_LOGINTYPE] != null ) {
            // Login data is given in the URL. Attempt to use it. We will fall
            // through if the data is not a valid login attempt.
            loginHandleLoginRequest( Request.QueryString[QSTR_LOGINTYPE] );
        } else if ( Request.QueryString[QSTR_START_SELF_SERVICE] != null ) {
            // This is a request to start the account self service process
            // Add the self service entry page to the page queue and redirect
            getAuthenticationState(Context).addPageToQueueHead("account_ss_entry", null);
            getAuthenticationState(Context).pageCompleted();
            Response.Redirect(getAuthenticationState(Context).getCurrentPage(), true);
        } else if ( Request.QueryString[QSTR_MSG_KEY] != null ) {
            // This is a request to display an error message after a failed login, do not
            // attempt silent authentication
        } else if (allowSilentAuth) {

            // Attempt to perform silent authentication, unless its been switched off for this session
            // or we have come from the logged-out page
            loginProcessDirectLogin();
        }
    }

    // If we've marked the browser session to indicate login has been started,
    // but we've ended up back at the login page the session has been terminated
    // for some reason.  The comes after checking for URL login requests because
    // Certificate authentication may need to come through that route.
    // If, however, we have been provided with a message to display, then
    // we have to re-show the login page to display the message.
    string sLogonMode = authGetUntrustedLogonType();
    if ((sLogonMode != null) && (sLogonMode.Trim() != "") && (Request.QueryString[QSTR_MSG_KEY] == null)) {
        HandleLogout(MSG_INFO, "SessionExpired");
    }

    if (Request.HttpMethod == "POST") {
        // This may or may not return
        loginProcessPost();
    }

    //
    // From here on in, setup the view controls, etc used to control the
    // page rendering.  Business logic is above.  Note business logic may
    // have modified viewControl, etc already.
    //
%>
<!-- #include file="~/app_data/auth/serverscripts/loginControls.aspxf" -->
<%
    envAdaptor.commitState();
    envAdaptor.destroy();
%>
<wi:Layout id="layout" runat="server" />
<%
}
%>
