// login.js
// Copyright (c) 2001 - 2006 Citrix Systems, Inc. All Rights Reserved.
// Web Interface 4.5.1.8215

function clearForm(loginForm) {
    loginForm.<%=ID_USER%>.value = "";
    loginForm.<%=ID_PASSWORD%>.value = "";
    if (loginForm.<%=ID_DOMAIN%>) {
        if (loginForm.<%=ID_DOMAIN%>.type != "hidden") {
            loginForm.<%=ID_DOMAIN%>.value = "";
        }
    }
    if (loginForm.<%=ID_CONTEXT%> != null) {
        loginForm.<%=ID_CONTEXT%>.value = "";
    }
    setDefaultFocus();
}

function setFocus(loginForm) {
    if (loginForm.<%=ID_TOKENCODE%> && (! loginForm.<%=ID_TOKENCODE%>.disabled)) {
        loginForm.<%=ID_TOKENCODE%>.focus();
    } else if (loginForm.<%=ID_PIN1%> && (! loginForm.<%=ID_PIN1%>.disabled)) {
        loginForm.<%=ID_PIN1%>.focus();
    } else if (loginForm.<%=ID_LOGIN_TYPE%> && (! loginForm.<%=ID_LOGIN_TYPE%>.disabled)) {
        if (loginForm.<%=ID_LOGIN_TYPE%>.value == "<%=AuthMethod.EXPLICIT%>") {
            setExplicitLoginFocus(loginForm);
        } else {
            if (loginForm.<%=ID_LOGIN_TYPE%>.options && (! loginForm.<%=ID_LOGIN_TYPE%>.options.disabled)) {
                if (loginForm.<%=ID_LOGIN_TYPE%>.options[loginForm.<%=ID_LOGIN_TYPE%>.selectedIndex].value  == "<%=AuthMethod.EXPLICIT%>") {
                    setExplicitLoginFocus(loginForm);
                } else {
                    var usrAgt = navigator.userAgent.toLowerCase();
                    var nav4 = ((usrAgt.indexOf('mozilla/4') != -1)
                                && (usrAgt.indexOf('msie') == -1)
                                && (usrAgt.indexOf('spoofer') == -1)
                                && (usrAgt.indexOf('compatible') == -1)
                                && (usrAgt.indexOf('opera') == -1)
                                && (usrAgt.indexOf('webtv') == -1));

                    if (!nav4 && (! document.getElementById("login").disabled)) {
                        document.getElementById("login").focus();
                    }
                }
            }
        }
    }
}

function setExplicitLoginFocus(loginForm) {
    if (loginForm.<%=ID_USER%>.value != "") {
        loginForm.<%=ID_PASSWORD%>.focus();
    } else if (!loginForm.<%=ID_USER%>.disabled) {
        loginForm.<%=ID_USER%>.focus();
    }
}

function setDefaultFocus() {
    var form = document.forms[0];
    if (form) {
        setFocus(form);
    }
}

function resetSessionTimeout() {
}

function onLoadLayout() {
    setDefaultFocus();
    return;
}

function usernameFieldContainsDomain(f) {
    return (f.<%=ID_USER%>.value.indexOf("@") != -1) ||
           (f.<%=ID_USER%>.value.indexOf("\\") != -1);
}

function setReconnectOptionsDisabled(f) {
    if (f.<%=ID_RECONNECT_LOGIN_OPTION%>) {
        var anonymous = false;
        if (f.<%=ID_LOGIN_TYPE%>) {
            anonymous = (f.<%=ID_LOGIN_TYPE%>.value == "<%=AuthMethod.ANONYMOUS%>");
        }

        var clientCondition = false;

        var chosenAppAccessMethod;
        if (f.<%=ID_RADIO_APP_ACCESS_REMOTE%>) {
            chosenAppAccessMethod = f.<%=ID_RADIO_APP_ACCESS_REMOTE%>.checked ? "<%=VAL_ACCESS_METHOD_REMOTE%>" : "<%=VAL_ACCESS_METHOD_STREAMING%>";
        } else {
            chosenAppAccessMethod = "<%=selectedAppAccessMethodString%>";
        }

        var chosenClient;

        if(chosenAppAccessMethod == "<%=VAL_ACCESS_METHOD_REMOTE%>") {
            if (f.<%=ID_CLIENT_TYPE%>) {
                chosenClient = f.<%=ID_CLIENT_TYPE%>.value;
            } else {
                chosenClient = "<%=selectedClientWhenRemoteAccessPreferredString%>";
            }
        } else {
            chosenClient = "<%=VAL_CLIENT_TYPE_LOCAL_ICA%>";
        }

        clientCondition = (chosenClient == "<%=VAL_CLIENT_TYPE_EMBEDDED_RDP%>") || ((<%=workspaceControl%> == <%=RC_JAVACLIENT_ONLY%>) && (chosenClient != "<%=VAL_CLIENT_TYPE_JAVA%>"));

        var reconnectDisabled = (anonymous || clientCondition);

        setDisabled(f.<%=ID_RECONNECT_LOGIN_OPTION%>, reconnectDisabled);
        var reconnectOption = reconnectDisabled ? "<%=VAL_NONE%>" : "<%=userReconnectLoginPref%>";
        for (var i = 0; i < f.<%=ID_RECONNECT_LOGIN_OPTION%>.length; i++) {
            if (f.<%=ID_RECONNECT_LOGIN_OPTION%>.options[i].value == reconnectOption) {
                f.<%=ID_RECONNECT_LOGIN_OPTION%>.options[i].selected = true;
                break;
            }
        }
<%
if (! sClientInfo.osWinCE()) {
%>
    setDisabled(document.getElementById("lblReconnectLogin"), reconnectDisabled);
<%
}
%>
    }
}

function setRemoteClientOptionsDisabled(f) {
    if (f.<%=ID_CLIENT_TYPE%>) {
        var accessMethodCondition = false;
        if (f.<%=ID_RADIO_APP_ACCESS_REMOTE%>) {
            accessMethodCondition = !(f.<%=ID_RADIO_APP_ACCESS_REMOTE%>.checked);
        }
        var clientDisabled = accessMethodCondition;

        setDisabled(f.<%=ID_CLIENT_TYPE%>, clientDisabled);
    }
}

function onChangeLoginType(f) {
     var explicit = (f.<%=ID_LOGIN_TYPE%>.value == "<%=AuthMethod.EXPLICIT%>");

     setDisabled(f.<%=ID_USER%>, ! explicit);
     setDisabled(f.<%=ID_PASSWORD%>, ! explicit);
     setDisabled(f.<%=ID_DOMAIN%>, ! explicit || usernameFieldContainsDomain(f));
     setDisabled(f.<%=ID_CONTEXT%>, ! explicit);
     setDisabled(f.<%=ID_TREE%>, ! explicit);
     setDisabled(f.<%=ID_PASSCODE%>, ! explicit);
     setDisabled(f.otc, ! explicit);

<%
if (! sClientInfo.osWinCE()) {
%>
     setDisabled(document.getElementById("lblCredentials"), ! explicit);
     setDisabled(document.getElementById("lblUserName"), ! explicit);
     setDisabled(document.getElementById("lblPasswd"), ! explicit);
     setDisabled(document.getElementById("lblDomain"), ! explicit || usernameFieldContainsDomain(f));
     setDisabled(document.getElementById("lblContext"), ! explicit);
     setDisabled(document.getElementById("lblTree"), ! explicit);
     setDisabled(document.getElementById("lblPasscode"), ! explicit);
     setDisabled(document.getElementById("lblOneTimeCode"), ! explicit);
<%
}
%>
     setReconnectOptionsDisabled(f);
}

function onChangeClientType(f) {
    setReconnectOptionsDisabled(f);
}

function onChangeAccessMethod(f) {
    setRemoteClientOptionsDisabled(f);
    setReconnectOptionsDisabled(f);
}

function onUsernameTextEntry(f) {
<%
if (! (viewControl.getRestrictDomains() && viewControl.getNumLoginDomains() == 0)) {
%>
    setDisabled(f.<%=ID_DOMAIN%>, usernameFieldContainsDomain(f));
<%
    if (! sClientInfo.osWinCE()) {
%>
    setDisabled(document.getElementById("lblDomain"), usernameFieldContainsDomain(f));
<%
    }
%>
<%
}
%>
}

function onTuringButtonClick() {
    username = document.getElementById("<%=ID_USER%>");

    if (username.value != "") {
        image = document.getElementById("imgTuring");
    	
        /* set the image src and make it visible, the random number is appended
         * to help prevent the browser caching the image */
        image.src = "pinsafe_image.aspx?username=" + username.value + 
                    "&random=" + Math.round(Math.random()*1000000);
                    
        image.style.display = "block";
    }
}

function openAdvOptions(f) {
    setItemInCookie("<%=COOKIE_ADV_OPTIONS_OPENED%>", "<%=VAL_TRUE%>");
    document.getElementById("<%=ID_OPENLINK_ADV_OPTIONS%>").style.display = "none";
    document.getElementById("<%=ID_CLOSELINK_ADV_OPTIONS%>").style.display = "";
    document.getElementById("<%=ID_TABLE_ADV_OPTIONS%>").style.display = "";
}

function closeAdvOptions(f) {
    setItemInCookie("<%=COOKIE_ADV_OPTIONS_OPENED%>", "<%=VAL_FALSE%>");
    document.getElementById("<%=ID_OPENLINK_ADV_OPTIONS%>").style.display = "";
    document.getElementById("<%=ID_CLOSELINK_ADV_OPTIONS%>").style.display = "none";
    document.getElementById("<%=ID_TABLE_ADV_OPTIONS%>").style.display = "none";
}

function setDisabled(item, disabled) {
    if (item) {
        item.disabled = disabled;
    }
}

function applyLanguage(loginForm) {
    loginForm.<%=ID_SUBMIT_MODE%>.value='<%=MODE_APPLY%>';
    loginForm.submit();
}
